#!/usr/bin/awk -f

function hextokana(str,  workstr,retstr){
    workstr = str;
    retstr = "";

    while ( length(workstr) > 0 ){
        if ( substr( workstr,1,3 ) ~ /=[A-F][0-9A-F]/ ){
            retstr = retstr kana[ substr( workstr,2,2) ];
            workstr = substr( workstr, 4);
        } else if ( substr( workstr,1,1 ) == "=" ) {
            workstr = substr( workstr, 2);
        } else {
            retstr = retstr substr( workstr,1,1 );
            workstr = substr( workstr, 2);
        }
    }

    return retstr ;
}

BEGIN{
# Array definition for HEX to Kana conversion

kana["A7"]=""; 
kana["A8"]=""; 
kana["A9"]=""; 
kana["AA"]=""; 
kana["AB"]=""; 
kana["AC"]=""; 
kana["AD"]=""; 
kana["AE"]=""; 
kana["AF"]=""; 

kana["B0"]=""; 
kana["B1"]=""; 
kana["B2"]=""; 
kana["B3"]=""; 
kana["B4"]=""; 
kana["B5"]=""; 
kana["B6"]=""; 
kana["B7"]=""; 
kana["B8"]=""; 
kana["B9"]=""; 
kana["BA"]=""; 
kana["BB"]=""; 
kana["BC"]=""; 
kana["BD"]=""; 
kana["BE"]=""; 
kana["BF"]=""; 
kana["C0"]=""; 
kana["C1"]=""; 
kana["C2"]=""; 
kana["C3"]=""; 
kana["C4"]=""; 
kana["C5"]=""; 
kana["C6"]=""; 
kana["C7"]=""; 
kana["C8"]=""; 
kana["C9"]=""; 
kana["CA"]=""; 
kana["CB"]=""; 
kana["CC"]=""; 
kana["CD"]=""; 
kana["CE"]=""; 
kana["CF"]=""; 
kana["D0"]=""; 
kana["D1"]=""; 
kana["D2"]=""; 
kana["D3"]=""; 
kana["D4"]=""; 
kana["D5"]=""; 
kana["D6"]=""; 
kana["D7"]=""; 
kana["D8"]=""; 
kana["D9"]=""; 
kana["DA"]=""; 
kana["DB"]=""; 
kana["DC"]=""; 
kana["DD"]=""; 
kana["DE"]=""; 
kana["DF"]=""; 


#Groups
    printf ("") > "groups";
    getline 
    while ( $0 !~ "^BEGIN:VCARD" ) {
        print $0 >> "groups";
        getline
    }

#Owner Info.
    printf ("") > "owner";
    do {
        print $0 >> "owner";
        if ( getline == 0 ){
            break;
        }
    } while ( $0 !~ "^BEGIN:VCARD" ); 

#   set field separater
    FS =":"
    count = 0;
}
{
    count++;
    tel_n = 0;
    mail_n = 0;
    telno[0] = telno[1] = telno[2] = "";
    tel_kind[0] = tel_kind[1] = tel_kind[2] = "";
    mailaddr[0] = mailaddr[1] = mailaddr[2] = "";
    mail_kind[0] = mail_kind[1] = mail_kind[2] = "";


    do {
# if EOF, exit.
        if ( getline == 0 ){
            break;
        }

        if ( $1 == "N;CHARSET=SHIFT_JIS" ){
            name = $2;
        } else if ( $1 == "SOUND;X-IRMC-N;CHARSET=SHIFT_JIS;ENCODING=QUOTED-PRINTABLE" ){
            yomigana = $2;
            if ( substr ( $2, length($2)) == "=" ) {
                getline
                yomigana = yomigana $0
            }
            yomigana = hextokana (yomigana);

        } else if ( $1 == "TEL;VOICE" ){
            telno[tel_n] = $2;
            tel_kind[tel_n] = "VOICE";
            tel_n++;

        } else if ( $1 == "TEL;VOICE;HOME" ){
            telno[tel_n] = $2;
            tel_kind[tel_n] = "VOICE_HOME";
            tel_n++;

        } else if ( $1 == "TEL;VOICE;WORK" ){
            telno[tel_n] = $2;
            tel_kind[tel_n] = "VOICE_WORK";
            tel_n++;

        } else if ( $1 == "TEL;CELL" ){
            telno[tel_n] = $2;
            tel_kind[tel_n] = "CELL";
            tel_n++;

        } else if ( $1 == "EMAIL;INTERNET" ){
            mailaddr[mail_n] = $2;
            mail_kind[mail_n] = "INTERNET";
            mail_n++;

        } else if ( $1 == "EMAIL;CELL" ){
            mailaddr[mail_n] = $2;
            mail_kind[mail_n] = "CELL";
            mail_n++;

        } else if ( $1 == "X-CLASS" ){
            xclass = $2;

        } else if ( $1 == "X-GNO" ){
            groupno = $2;

        } else if ( $1 == "X-JPG-MDNO" ){
            mdno = $2;

        } else if ( $1 == "X-JPGSH-RING-FILE" ){
            ringfile = $2;

        } else if ( $1 == "X-JPGSH-VIB-NO" ){
            vibno = $2;

        } else if ( $1 == "X-JPGSH-MRING-FILE" ){
            mailringfile = $2;

        } else if ( $1 == "X-JPGSH-MVIB-NO" ){
            mailvibno = $2;

        } else if ( $1 == "X-JPGSH-PICT-FILE" ){
            pictfile = $2;

        } else if ( $1 == "X-JPGSH-MAILH-NO" ){
            mailfolder = $2;

        } else if ( $1 == "X-JPGSH-PERSONAL" ){
            personalinfo = $2;

        }

    } while ( $0 !~ "^BEGIN:VCARD" ); 

    print count","\
        "\"'" name "\"" ","\
        "\"'" yomigana "\"" ","\
        "\"'" telno[0] "\"" ","tel_kind[0]","\
        "\"'" telno[1] "\"" ","tel_kind[1]","\
        "\"'" telno[2] "\"" ","tel_kind[2]","\
        "\"'" mailaddr[0] "\"" ","mail_kind[0]","\
        "\"'" mailaddr[1] "\"" ","mail_kind[1]","\
        "\"'" mailaddr[2] "\"" ","mail_kind[2]","\
        xclass","\
        groupno","\
        mdno","\
        ringfile","\
        vibno","\
        mailringfile","\
        mailvibno","\
        pictfile","\
        mailfolder","\
        personalinfo ;
}
